exchange/src/auditor/test-auditor.sh

252 lines
7.7 KiB
Bash
Raw Normal View History

2019-08-22 15:30:02 +02:00
#!/bin/bash
2019-08-22 15:43:30 +02:00
# Setup database which was generated from a perfectly normal
# exchange-wallet interaction and run the auditor against it.
#
# Check that the auditor report is as expected.
#
# Requires 'jq' tool and Postgres superuser rights!
2019-08-22 15:30:02 +02:00
set -eu
2019-08-23 15:10:10 +02:00
2019-09-02 03:32:28 +02:00
# Which tests should we run, used to make it easy to
# only run a subset of the tests. To only run a subset,
# pass the numbers of the tests to run as the FIRST
# argument to test-auditor.sh
ALL_TESTS=`seq 1 3`
TESTS=${1:-$ALL_TESTS}
function exit_skip() {
echo $1
exit 77
}
function exit_fail() {
echo $1
kill `jobs -p`
exit 1
}
function run_audit () {
# Launch bank
echo "Launching bank"
taler-bank-manage -c test-auditor.conf serve-http 2>bank.err >bank.log &
while true
do
echo -n "."
wget http://localhost:8082/ -o /dev/null -O /dev/null >/dev/null && break
sleep 1
done
echo "OK"
# Run the auditor!
echo "Running audit(s)"
taler-auditor -r -c test-auditor.conf -m $MASTER_PUB > test-audit.json || exit_fail "auditor failed"
2019-09-02 03:32:28 +02:00
taler-wire-auditor -r -c test-auditor.conf -m $MASTER_PUB > test-wire-audit.json || exit_fail "wire auditor failed"
echo "Shutting down services"
kill `jobs -p`
echo "TeXing"
2019-09-02 08:01:55 +02:00
../../contrib/render.py test-audit.json test-wire-audit.json < ../../contrib/auditor-report.tex.j2 > test-report.tex || exit_fail "Renderer failed"
2019-09-02 08:01:55 +02:00
timeout 10 pdflatex test-report.tex >/dev/null || exit_fail "pdflatex failed"
2019-09-02 03:32:28 +02:00
timeout 10 pdflatex test-report.tex >/dev/null
}
2019-08-23 15:17:54 +02:00
# test required commands exist
echo "Testing for jq"
jq -h > /dev/null || exit_skip "jq required"
2019-08-23 15:17:54 +02:00
echo "Testing for taler-bank-manage"
taler-bank-manage -h >/dev/null </dev/null || exit_skip "taler-bank-manage required"
2019-08-23 15:17:54 +02:00
echo "Testing for pdflatex"
which pdflatex > /dev/null </dev/null || exit_skip "pdflatex required"
2019-08-23 15:17:54 +02:00
2019-08-23 15:10:10 +02:00
echo "Database setup"
2019-08-22 15:30:02 +02:00
DB=taler-auditor-test
2019-08-22 15:43:30 +02:00
dropdb $DB 2> /dev/null || true
createdb -T template0 $DB || exit_skip "could not create database"
2019-08-23 15:17:54 +02:00
2019-08-22 15:48:35 +02:00
# Import pre-generated database, -q(ietly) using single (-1) transaction
2019-08-22 15:43:30 +02:00
psql $DB -q -1 -f ../benchmark/auditor-basedb.sql > /dev/null
2019-08-22 15:30:02 +02:00
MASTER_PUB=`cat ../benchmark/auditor-basedb.mpub`
2019-09-02 03:32:28 +02:00
test_1() {
echo "===========1: normal run==========="
run_audit
2019-08-23 15:10:10 +02:00
echo "Checking output"
2019-08-22 15:43:30 +02:00
# if an emergency was detected, that is a bug and we should fail
echo -n "Test for emergencies... "
jq -e .emergencies[0] < test-audit.json > /dev/null && exit_fail "Unexpected emergency detected in ordinary run" || echo OK
2019-09-02 08:01:55 +02:00
jq -e .emergencies_by_count[0] < test-audit.json > /dev/null && exit_fail "Unexpected emergency by count detected in ordinary run" || echo OK
echo -n "Test for wire inconsistencies... "
jq -e .wire_out_amount_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected wire out inconsistency detected in ordinary run"
jq -e .reserve_in_amount_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected reserve in inconsistency detected in ordinary run"
jq -e .missattribution_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected missattribution inconsistency detected in ordinary run"
jq -e .row_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected row inconsistency detected in ordinary run"
jq -e .row_minor_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected minor row inconsistency detected in ordinary run"
jq -e .lag_details[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected lag detected in ordinary run"
jq -e .wire_format_inconsistencies[0] < test-wire-audit.json > /dev/null && exit_fail "Unexpected wire format inconsistencies detected in ordinary run"
2019-09-02 08:01:55 +02:00
# FIXME: check operation balances are correct (once we have more transaction types)
# FIXME: check revenue summaries are correct (once we have more transaction types)
echo OK
echo -n "Test for wire amounts... "
WIRED=`jq -r .total_wire_in_delta_plus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Expected total wire delta plus wrong, got $WIRED"
fi
WIRED=`jq -r .total_wire_in_delta_minus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Expected total wire delta minus wrong, got $WIRED"
fi
WIRED=`jq -r .total_wire_out_delta_plus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Expected total wire delta plus wrong, got $WIRED"
fi
WIRED=`jq -r .total_wire_out_delta_minus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Expected total wire delta minus wrong, got $WIRED"
fi
WIRED=`jq -r .total_missattribution_in < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Expected total missattribution in wrong, got $WIRED"
fi
echo "OK"
2019-09-02 03:32:28 +02:00
}
2019-09-02 03:32:28 +02:00
test_2() {
echo "===========2: reserves_in inconsitency==========="
echo "UPDATE reserves_in SET credit_val=5 WHERE reserve_in_serial_id=1" | psql $DB
2019-08-22 15:30:02 +02:00
run_audit
echo -n "Test for inconsistency detection... "
ROW=`jq .reserve_in_amount_inconsistencies[0].row < test-wire-audit.json`
if test $ROW != 1
then
exit_fail "Row wrong"
fi
WIRED=`jq -r .reserve_in_amount_inconsistencies[0].amount_wired < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:10"
then
exit_fail "Amount wrong"
fi
EXPECTED=`jq -r .reserve_in_amount_inconsistencies[0].amount_exchange_expected < test-wire-audit.json`
if test $EXPECTED != "TESTKUDOS:5"
then
exit_fail "Expected amount wrong"
fi
2019-09-02 03:32:28 +02:00
WIRED=`jq -r .total_wire_in_delta_minus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Wrong total wire_in_delta_minus, got $WIRED"
fi
DELTA=`jq -r .total_wire_in_delta_plus < test-wire-audit.json`
if test $DELTA != "TESTKUDOS:5"
then
exit_fail "Expected total wire delta plus wrong"
fi
echo OK
# Undo database modification
echo "UPDATE reserves_in SET credit_val=10 WHERE reserve_in_serial_id=1" | psql $DB
2019-09-02 03:32:28 +02:00
}
# Check for incoming wire transfer amount given being
# lower than what exchange claims to have received.
test_3() {
echo "===========3: reserves_in inconsitency==========="
echo "UPDATE reserves_in SET credit_val=15 WHERE reserve_in_serial_id=1" | psql $DB
run_audit
2019-09-02 08:01:55 +02:00
EXPECTED=`jq -r .reserve_balance_summary_wrong_inconsistencies[0].auditor < test-audit.json`
if test $EXPECTED != "TESTKUDOS:5.01"
2019-09-02 03:32:28 +02:00
then
2019-09-02 08:01:55 +02:00
exit_fail "Expected reserve balance summary amount wrong, got $EXPECTED (auditor)"
fi
EXPECTED=`jq -r .reserve_balance_summary_wrong_inconsistencies[0].exchange < test-audit.json`
if test $EXPECTED != "TESTKUDOS:0.01"
then
exit_fail "Expected reserve balance summary amount wrong, got $EXPECTED (exchange)"
2019-09-02 03:32:28 +02:00
fi
WIRED=`jq -r .total_loss_balance_insufficient < test-audit.json`
2019-09-02 08:01:55 +02:00
if test $WIRED != "TESTKUDOS:0"
2019-09-02 03:32:28 +02:00
then
exit_fail "Wrong total loss from insufficient balance, got $WIRED"
fi
ROW=`jq -e .reserve_in_amount_inconsistencies[0].row < test-wire-audit.json`
if test $ROW != 1
then
exit_fail "Row wrong, got $ROW"
fi
WIRED=`jq -r .reserve_in_amount_inconsistencies[0].amount_exchange_expected < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:15"
then
exit_fail "Wrong amount_exchange_expected, got $WIRED"
fi
WIRED=`jq -r .reserve_in_amount_inconsistencies[0].amount_wired < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:10"
then
exit_fail "Wrong amount_wired, got $WIRED"
fi
WIRED=`jq -r .total_wire_in_delta_minus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:5"
then
exit_fail "Wrong total wire_in_delta_minus, got $WIRED"
fi
WIRED=`jq -r .total_wire_in_delta_plus < test-wire-audit.json`
if test $WIRED != "TESTKUDOS:0"
then
exit_fail "Wrong total wire_in_delta_plus, got $WIRED"
fi
# Undo database modification
echo "UPDATE reserves_in SET credit_val=10 WHERE reserve_in_serial_id=1" | psql $DB
}
fail=0
for i in $TESTS
do
test_$i
if test 0 != $fail
then
break
fi
done
2019-08-23 15:10:10 +02:00
echo "Cleanup"
2019-09-02 03:32:28 +02:00
#$ dropdb $DB
2019-08-22 15:30:02 +02:00
2019-08-22 15:43:30 +02:00
exit $fail